/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef HELP_H
#define HELP_H

#include <gtkmm/window.h>
#include <gtkmm/label.h>
#include <gtkmm/toolbar.h>
#include <gtkmm/treeview.h>
#include <gtkmm/treestore.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/textview.h>
#include <gtkmm/box.h>
#include <gtkmm/paned.h>
#include <gtkmm/uimanager.h>
#include <gtkmm/actiongroup.h>
#include <gtkmm/stock.h>
#include <glib.h>
#include <iostream>
using namespace std;

// Class to add column to the TreeView
class ModelColumns : public Gtk::TreeModel::ColumnRecord
{
public:
  ModelColumns()  { add(col_text); }
  Gtk::TreeModelColumn<Glib::ustring> col_text;
};

// OpenLDev Help main class
class help : public Gtk::Window
{  
public:
  help();
  ~help() { }
  
  void create_toolbar();
  void populate_treeview();
  
  void on_treeview(GdkEventButton*);
  void open_file();
  
  void on_quit();
  void on_back();
  void on_next();
  void on_home();
  
private:
  Gtk::TreeView *treeview;
  Gtk::ScrolledWindow *swin, *swin2;
  Gtk::TextView *textview;
  Gtk::HPaned *hbox;
  Gtk::VBox *vbox;
  
  Gtk::Toolbar *toolbar;
  Glib::RefPtr<Gtk::UIManager> uimanager;
  Glib::RefPtr<Gtk::ActionGroup> actgroup;
  
  deque<Glib::ustring> title;
};

#endif
