/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef NEW_H
#define NEW_H

#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/label.h>
#include <gtkmm/box.h>
#include <gtkmm/separator.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/entry.h>
#include <gtkmm/table.h>
#include <gtkmm/fixed.h>
#include <gtkmm/combo.h>
#include <iostream>
#include <glib.h>
using namespace std;

// New file/project class
class new_project_dialog : public Gtk::Dialog
{
public:
  new_project_dialog ();
  ~new_project_dialog();

  void initialize_objects();
  void populate_combobox();
  void on_apply();
  void on_cancel();
  void on_browse();

  bool key_pressed_name(GdkEventKey*);
  Glib::ustring get_filename();

  Glib::ustring check_for_errors();
  Glib::ustring create_odp_file_text(Glib::ustring&);
  void create_location();
  void run_copy_extract_rm (Glib::ustring, Glib::ustring, Glib::ustring);
  void edit_configure_file (Glib::ustring);
  void edit_makefiles (Glib::ustring, Glib::ustring);

private:
  Gtk::Dialog *dialog;
  Gtk::Button *cancel, *apply, *browse;
  Gtk::Label *label, *label1, *label2, *label3, *label4, *label5, *label6;
  Gtk::VBox *vbox, *vbox2, *vbox3;
  Gtk::HBox *hbox, *hbox2, *hbox3, *hbox4;
  Gtk::Entry *name, *author, *email, *homepage, *version, *location;
  Gtk::Combo *combobox;
  Gtk::HSeparator *hseparator, *hseparator2;
  Glib::ustring file_location;
};

#endif
